<script>
	import { getContext, onMount } from 'svelte'
	export let position = 'topright'

	let controls
	let controlsElement

	let map = getContext('map')()
	onMount(async () => {
		const Leaflet = await import('leaflet')
		class Control extends Leaflet.Control {
			constructor(el, position) {
				super({ position })
				this.el = el
			}
			onAdd() {
				return this.el
			}
			onRemove() {}
		}
		controls = new Control(controlsElement, position).addTo(map)
		return () => {
			controls?.remove()
		}
	})
</script>

<div bind:this={controlsElement} class={$$restProps.class}>
	{#if controls}
		<slot {controls} />
	{/if}
</div>
